;
;  ******  ******          ******  ******  ******
;  **  **  **  **              **  **          **           MEBEA 
;  **  **  **  **  ******      **  **          **
;  ******  **  **  **          **  ******  ******          DC MOTOR
;  **  **  **  **  **          **      **  **    
;  **  **  **  **  **          **      **  **          SPEED CONTROLLER
;  ******  ******  ******      **  ******  ******
;                                                                             
;   ******************************************************************
;   *                 Software written by                            *
;   *								     *
;   * 		     B.L.Brown & R.G.Badman                          *
;   *								     *
;   *       TECHNICAL SERVICES - THE WAIKATO POLYTECHNIC             *
;   *                                                                *
;   *                 HAMILTON, NEW ZEALAND                          *
;   *								     *	   
;   *	                 10 December 1997	                     *
;   ******************************************************************
;
;   ******************************************************************
;   ***								   ***
;   ***   Version C. 10 December 1997 - This version has separate  ***  
;   ***   speed  control  routines for forward  and  reverse, and  ***
;   ***   field cutoff when accelerator is closed. 	           ***
;   ***								   ***
;   ******************************************************************
;
;-------------------------------------------------------------------------------
; V1.12
;
$SYMBOLS
$MOD752
;-------------------------------------------------------------------------------
;DIRECT RAM MEMORY MAP
;			DATA	03FH    ;
;			DATA	03EH    ;
;			DATA	03DH    ;
;			DATA	03CH    ;
;			DATA	03BH    ;
;			DATA	03AH    ;
;			DATA	039H    ;
;			DATA	038H    ;
STACK			DATA	037H    ;
;			DATA	036H    ;
;			DATA	035H    ;
;			DATA	034H    ;
;			DATA	033H    ;
;			DATA	032H    ;
;			DATA	031H    ;
;			DATA	030H	;
;-------------------------------------------------------------------------------
; BYTE ADDRESSES for BIT ADDRESSABLE MEMORY
;			DATA	02FH	;
;			DATA	02EH	;
;			DATA	02DH	;
;			DATA	02CH	;
;			DATA	02BH	;
;			DATA	02AH	;
;			DATA	029H	;
;			DATA	028H	;
;			DATA	027H	;
;			DATA	026H	;
;			DATA	025H	;
;			DATA	024H	;
;			DATA	023H	;
;			DATA	022H	;
;			DATA	021H	;
;			DATA	020H	;
;-------------------------------------------------------------------------------
; REGISTER BANK 3 (11)			;
;			DATA	01FH	;
;			DATA	01EH    ;
;			DATA	01DH    ;
;			DATA	01CH    ;
;			DATA	01BH    ;
;			DATA	01AH	;
;			DATA	019H	;
;			DATA	018H	;
;-------------------------------------------------------------------------------
; REGISTER BANK 2 (10)
;			DATA	017H	;
;			DATA	016H    ;
;			DATA	015H    ;
;			DATA	014H    ;
;			DATA	013H    ;
;			DATA	012H    ;
;			DATA	011H	;
;			DATA	010H	;
;-------------------------------------------------------------------------------
; REGISTER BANK 1 (01)
;			DATA	00FH	;
;			DATA	00EH    ;
;			DATA	00DH    ;
;			DATA	00CH    ;
;			DATA	00BH    ;
;			DATA	00AH    ;
;			DATA	009H    ;
;			DATA	008H	;
;-------------------------------------------------------------------------------
; REGISTER BANK 0 (00)
;			DATA	007H	;
;			DATA	006H    ;
;			DATA	005H    ;
;			DATA	004H    ;
;			DATA	003H    ;
;			DATA	002H    ;
;			DATA	001H    ;
;	       		DATA	000H	;
;-------------------------------------------------------------------------------
; BIT ADDRESSED MEMORY					 	 BYTE ADDRESS
;			BIT	07FH	;
;			BIT	07EH	;
;			BIT	07DH	;
;			BIT	07CH	;
;			BIT	07BH	;
;			BIT	07AH	;
;			BIT	079H	;
;			BIT	078H	;
;-------------------------------------------------------------------- 02FH
;			BIT	077H	;
;			BIT	076H	;
;			BIT	075H	;
;			BIT	074H	;
;			BIT	073H	;
;			BIT	072H	;
;			BIT	071H	;
;			BIT	070H	;
;-------------------------------------------------------------------- 02EH
;			BIT	06FH	;
;			BIT	06EH	;
;			BIT	06DH	;
;			BIT	06CH	;
;			BIT	06BH	;
;			BIT	06AH	;
;			BIT	069H	;
;			BIT	068H	;
;-------------------------------------------------------------------- 02DH
;			BIT	067H	;
;			BIT	066H	;
;			BIT	065H	;
;			BIT	064H	;
;			BIT	063H	;
;			BIT	062H	;
;			BIT	061H	;
;			BIT	060H	;
;-------------------------------------------------------------------- 02CH
;			BIT	05FH	;
;			BIT	05EH	;
;			BIT	05DH	;
;			BIT	05CH	;
;			BIT	05BH	;
;			BIT	05AH	;
;			BIT	059H	;
;			BIT	058H	;
;-------------------------------------------------------------------- 02BH
;			BIT	057H	;
;			BIT	056H	;
;			BIT	055H	;
;			BIT	054H	;
;			BIT	053H	;
;			BIT	052H	;
;			BIT	051H	;
;			BIT	050H	;
;-------------------------------------------------------------------- 02AH
;			BIT	04FH	;
;			BIT	04EH	;
;			BIT	04DH	;
;			BIT	04CH	;
;			BIT	04BH	;
;			BIT	04AH	;
;			BIT	049H	;
;			BIT	048H	;
;-------------------------------------------------------------------- 029H
;			BIT	047H	;
;			BIT	046H	;
;			BIT	045H	;
;			BIT	044H	;
;			BIT	043H	;
;			BIT	042H	;
;			BIT	041H	;
;			BIT	040H	;
;-------------------------------------------------------------------- 028H
;			BIT	03FH	;
;			BIT	03EH	;
;			BIT	03DH	;
;			BIT	03CH	;
;			BIT	03BH	;
;			BIT	03AH	;
;			BIT	039H	;
;			BIT	038H	;
;-------------------------------------------------------------------- 027H
;			BIT	037H	;
;			BIT	036H	;
;			BIT	035H	;
;			BIT	034H	;
;			BIT	033H	;
;			BIT	032H	;
;			BIT	031H	;
;			BIT	030H	;
;-------------------------------------------------------------------- 026H
;			BIT	02FH	;
;			BIT	02EH	;
;			BIT	02DH	;
;			BIT	02CH	;
;			BIT	02BH	;
;			BIT	02AH	;
;			BIT	029H	;
;			BIT	028H	;
;-------------------------------------------------------------------- 025H
;			BIT	027H	;
;			BIT	026H	;
;			BIT	025H	;
;			BIT	024H	;
;			BIT	023H	;
;			BIT	022H	;
;			BIT	021H	;
;			BIT	020H	;
;-------------------------------------------------------------------- 024H
;			BIT	01FH	;
;			BIT	01EH	;
;			BIT	01DH	;
;			BIT	01CH	;
;			BIT	01BH	;
;			BIT	01AH	;
;			BIT	019H	;
;			BIT	018H	;
;-------------------------------------------------------------------- 023H
;			BIT	017H	;
;			BIT	016H	;
;			BIT	015H	;
;			BIT	014H	;
;			BIT	013H	;
;			BIT	012H	;
;			BIT	011H	;
;			BIT	010H	;
;-------------------------------------------------------------------- 022H
;			BIT	00FH	;
;			BIT	00EH	;
;			BIT	00DH	;
;			BIT	00CH	;
;			BIT	00BH	;
;			BIT	00AH	;
;			BIT	009H	;
;			BIT	008H	;
;-------------------------------------------------------------------- 021H
;			BIT	007H	;
;			BIT	006H	;
;			BIT	005H	;
;			BIT	004H	;
;			BIT	003H	;
;			BIT	002H	;
REV			BIT	001H	; '1' is ON
FWD     		BIT	000H	; '1' is ON
;-------------------------------------------------------------------- 020H
; Hardware equates

RUN_INPUT		BIT	P3.5	; Input 1, RUN (Permanent 0)
FWD_REV_INPUT		BIT	P3.6	; Input 2, FWD/REV
INPUT3			BIT	P3.7

REV_INDICATOR		BIT	P0.2	; Output 1, REVERSE indicator
OUTPUT2			BIT	P1.5

SW1			BIT	P1.6	; 4 way DIP switch
SW2			BIT	P1.7
SW3			BIT	P0.3
SW4			BIT	P3.1

FWD_FIELD		BIT	P3.4	; Field direction FWD ('0' is ON)
REV_FIELD		BIT	P3.3	; Field direction REV ('0' is ON)

RUN_INDICATOR		BIT	P3.2

ST			BIT	P3.0	; Watchdog strobe input

;-------------------------------------------------------------------------------
ORG 0000H				; Reset vector.
	AJMP INITIALIZE
ORG 0003H				; External interrupt 0 vector.
	AJMP INITIALIZE
ORG 000BH				; Timer 0 interrupt vector.
	AJMP INITIALIZE
ORG 0013H				; External interrupt 1 vector.
	AJMP INITIALIZE
ORG 001BH				; Timer I overflow interrupt vector.
	AJMP INITIALIZE
ORG 0023H				; I2C serial
	AJMP INITIALIZE
ORG 002BH				; ADC
	AJMP INITIALIZE
ORG 0033H				; PWM
	AJMP INITIALIZE


ORG 0100H				; Start address for program.
;-------------------------------------------------------------------------------
INITIALIZE:				; This routine performed once only.


	MOV	SP,#STACK		; Set stack pointer
	CLR	EA			; Global interrupt disable
	MOV	PWCM,#0
	

	MOV	A,#0			; Read ADC a few times
	ACALL	READ_ADC		; (as sometimes first will not be 0)
	MOV	A,#0
	ACALL	READ_ADC
	MOV	A,#0
	ACALL	READ_ADC
	
;-------------------------------------------------------------------------------
MAIN:					; Main program loop

  M1:
	SETB	FWD_FIELD		; Field off
	SETB	REV_FIELD
	SETB	REV_INDICATOR		; Not reverse
	MOV	PWENA,#0		; Disable PWM output

	CPL	ST			; Toggle watchdog strobe

	ACALL	GET_SPEED		; Check SPEED input 0 before starting
	JNZ	 M1

M2:
	ACALL	FIELD_ROUTINE		; Set direction (field control)

	ACALL	SET_FREQ		; Set freq


	JNB	FWD_FIELD,M3		; If forward, continue at M3
	
	
	ACALL	GET_SPEED_REV		; Set speed - REVERSE
	MOV	PWCM,A

	CPL	ST			; Toggle watchdog strobe
	AJMP	M2


M3:	
	ACALL	GET_SPEED		; Set speed - FORWAD
	MOV	PWCM,A

	CPL	ST			; Toggle watchdog strobe
	AJMP	M2
	
;-----------------------------------------------------------------------------
GET_SPEED:		; FORWARD DIRECTION

	MOV	A,#3			; Get MIN setting from MIN-SPEED pot
	ACALL	READ_ADC
	MOV	B,A

	MOV	A,#4			; Get SPEED input from twist grip
	ACALL	READ_ADC		;			   control

	CLR	C			; Calc SPEED-MIN
	SUBB	A,B
	MOV	B,A
	
	JNC	SS1			; Clamp minimum to zero
	MOV	B,#0

  SS1:	

	MOV	A,#0			; Get MAX setting from SPEED-GAIN pot
	ACALL	READ_ADC

	MUL	AB			; Multiply by MAX

					; Now divide by 64 (div by 2 6 times)


SS3:	CLR	C			; Divide by 2
	XCH	A,B
	RRC	A
	XCH	A,B
	RRC	A

	CLR	C			; Divide by 2
	XCH	A,B
	RRC	A
	XCH	A,B
	RRC	A

	CLR	C			; Divide by 2
	XCH	A,B
	RRC	A
	XCH	A,B
	RRC	A

	CLR	C			; Divide by 2
	XCH	A,B
	RRC	A
	XCH	A,B
	RRC	A

	CLR	C			; Divide by 2
	XCH	A,B
	RRC	A
	XCH	A,B
	RRC	A

	CLR	C			; Divide by 2
	XCH	A,B
	RRC	A
	XCH	A,B
	RRC	A


	XCH	A,B			; Limit to 255
	JZ	SS2
	MOV	B,#255
  SS2:
	XCH	A,B			; Output in A

	RET
;-------------------------------------------------------------------------------

GET_SPEED_REV:	; Similar to GET_SPEED but reduced torque (for reverse)

	MOV	A,#3			; Get MIN setting
	ACALL	READ_ADC
	MOV	B,A

	MOV	A,#4			; Get SPEED input
	ACALL	READ_ADC

	CLR	C			; Calc SPEED-MIN
	SUBB	A,B
	MOV	B,A
	
	JNC	SS4			; Clamp minimum to zero
	MOV	B,#0

  SS4:	

	MOV	A,#0			; Get MAX setting
	ACALL	READ_ADC

	MUL	AB			; Multiply by MAX

					; Now divide by 128 (div by 2 7 times)
	CLR	C			; Divide by 2
	XCH	A,B
	RRC	A
	XCH	A,B
	RRC	A

	CLR	C			; Divide by 2
	XCH	A,B
	RRC	A
	XCH	A,B
	RRC	A

	CLR	C			; Divide by 2
	XCH	A,B
	RRC	A
	XCH	A,B
	RRC	A

	CLR	C			; Divide by 2
	XCH	A,B
	RRC	A
	XCH	A,B
	RRC	A

	CLR	C			; Divide by 2
	XCH	A,B
	RRC	A
	XCH	A,B
	RRC	A

	CLR	C			; Divide by 2
	XCH	A,B
	RRC	A
	XCH	A,B
	RRC	A

	CLR	C			; Divide by 2
	XCH	A,B
	RRC	A
	XCH	A,B
	RRC	A


	XCH	A,B			; Limit to 255
	JZ	SS5
	MOV	B,#255
  SS5:
	XCH	A,B			; Output in A

	RET

;-------------------------------------------------------------------------------
FIELD_ROUTINE:  ; turns field OFF when accelerator closed. 

	ACALL	GET_SPEED		; } If accelerator non-zero then 
	JNZ	SD_EXIT			; }                  exit routine

	SETB	FWD_FIELD		; } Accelerator is zero,  
	SETB	REV_FIELD		; }        so turn field OFF
SD1:
	CPL	ST			; Toggle watchdog timer
	ACALL	GET_SPEED		; } Wait (loop) until non-zero accelerator
	JZ	SD1			; }

	MOV	C,FWD_REV_INPUT		; Get desired direction from switch
	MOV	FWD,C			; ('1' is forward - store in FWD) 
        CPL     C
        MOV     REV,C			; Store complement in REV			
					
	MOV	C,FWD			; Now turn ON field forward or reverse
	CPL	C
	MOV	FWD_FIELD,C		; Do it

	ACALL	DELAY2			; Wait a while
  
	MOV	C,REV			; Continue turn ON field forward or reverse
	CPL	C
	MOV	REV_FIELD,C		; Do it
	
	MOV	REV_INDICATOR,C		; Indicate direction on output 1

	ACALL	DELAY2			; Wait a while
 
SD_EXIT:

	RET
;-------------------------------------------------------------------------------
SET_FREQ:

	MOV	A,#2			; Get frequency from preset
	ACALL	READ_ADC
	CPL	A
	MOV	B,#3			; Divide by 3 and multiply by 3
	DIV	AB			; to reduce number of steps
	MOV	B,#3
	MUL	AB
	MOV	PWMP,A			; Set freq
	MOV	PWENA,#0FFH		; Enable PWM 

	RET
;-------------------------------------------------------------------------------
READ_ADC:				; Read ADC, channel from ACC, result
					; in ACC when complete

	CLR	ACC.7
	CLR	ACC.6
	SETB	ACC.5			; Enable ADC, ENADC=1
	CLR	ACC.4
	SETB	ACC.3			; Start ADC, ADCS=1
	
	MOV	ADCON,A			; Do it

  ADC_LOOP:
	MOV	A,ADCON			; Wait for completion
	JNB	ACC.4,ADC_LOOP

	MOV	A,ADAT			; Return with result in ACC
	
	RET
;-------------------------------------------------------------------------------

DELAY2:
	
	MOV	R6,#01FH		; Short delay
	AJMP	LOOP	

DELAY:
	MOV	R6,#0FFH		; Outer loop
  LOOP:
	MOV	R7,#0FFH		; Inner loop
	DJNZ	R7,$
	CPL	ST			; Toggle watchdog strobe
	DJNZ	R6,LOOP
	RET
;-------------------------------------------------------------------------------
END;
